apiVersion: k8s.mariadb.com/v1alpha1
kind: MariaDB
metadata:
  name: {{ k8s_mariadbop_dbname }}
  namespace: {{ k8s_mariadbop_namespace }}
spec:
  serviceAccountName: "{{ k8s_mariadbop_service_account }}"

  rootPasswordSecretKeyRef:
    name: "{{ k8s_mariadbop_name }}-root"
    key: password

  username: mariadb
  database: mariadb

  passwordSecretKeyRef:
    name: "{{ k8s_mariadbop_name }}-password"
    key: password

  storage:
    size: {{ k8s_mariadbop_storagesize }}
    storageClassName: {{ k8s_mariadbop_storageclassname }}
    resizeInUseVolumes: true
    waitForVolumeResize: true
    volumeClaimTemplate:
      accessModes:
      - ReadWriteOnce
      resources:
        requests:
          storage: 2Gi
      storageClassName: {{ k8s_mariadbop_storageclassname }}

  volumes:
    - name: "{{ k8s_mariadbop_name }}-backup"
      persistentVolumeClaim:
        claimName: "{{ k8s_mariadbop_name }}-backup"
{% if k8s_mariadbop_vault_server != "" %}
    - name: secrets-store-inline
      csi:
        driver: secrets-store.csi.k8s.io
        readOnly: true
        volumeAttributes:
          secretProviderClass: "{{ k8s_mariadbop_name }}vaulty"
{% endif %}
  volumeMounts:
    - name: "{{ k8s_mariadbop_name }}-backup"
      mountPath: /var/mariadb/backup/
{% if k8s_mariadbop_vault_server != "" %}
    - name: secrets-store-inline
      mountPath: "/mnt/secrets-store"
      readOnly: true
{% endif %}

  replicas: {{ k8s_mariadbop_instances | int }}

  # point to an existing MaxScale instance. Doing this will delegate tasks such as primary failover to MaxScale.
  # maxScaleRef:
  #   name: maxscale

  # provision a MaxScale instance and set 'spec.maxScaleRef' automatically.
  maxScale:
    enabled: true

    kubernetesService:
      type: LoadBalancer

    connection:
      secretName: mxs-galera-conn
      port: 3306

  galera:
    enabled: true
    primary:
      podIndex: 0
      automaticFailover: true
    sst: mariabackup
    availableWhenDonor: false
    galeraLibPath: /usr/lib/galera/libgalera_smm.so
    replicaThreads: 1
    providerOptions:
      gcs.fc_limit: '64'
    agent:
      image: docker-registry3.mariadb.com/mariadb-operator/mariadb-operator:{{ k8s_mariadbop_chart_version}}
      port: 5555
      kubernetesAuth:
        enabled: true
      gracefulShutdownTimeout: 1s
    recovery:
      enabled: true
      minClusterSize: 33%
      clusterMonitorInterval: 15s
      clusterHealthyTimeout: 60s
      clusterBootstrapTimeout: 10m
      podRecoveryTimeout: 3m
      podSyncTimeout: 3m
    initContainer:
      image: docker-registry3.mariadb.com/mariadb-operator/mariadb-operator:{{ k8s_mariadbop_chart_version }}
    initJob:
      metadata:
        labels:
          sidecar.istio.io/inject: "false"
      args:
        - "--verbose"
      affinity:
        antiAffinityEnabled: true
      resources:
        requests:
          cpu: 100m
          memory: 128Mi
        limits:
          memory: 1Gi
    config:
      reuseStorageVolume: false
      volumeClaimTemplate:
        resources:
          requests:
            storage: 300Mi
        accessModes:
          - ReadWriteOnce

  service:
    type: LoadBalancer

  connection:
    secretName: mariadb-galera-conn
    secretTemplate:
      key: dsn

  primaryService:
    type: LoadBalancer

  secondaryService:
    type: LoadBalancer

  affinity:
    antiAffinityEnabled: {{ k8s_mariadbop_antiaffinity }}

  tolerations:
    - key: "k8s.mariadb.com/ha"
      operator: "Exists"
      effect: "NoSchedule"

  podDisruptionBudget:
    maxUnavailable: 50%

  updateStrategy:
    type: ReplicasFirstPrimaryLast

  myCnf: |
    [mariadb]
    bind-address=*
    default_storage_engine=InnoDB
    binlog_format=row
    innodb_autoinc_lock_mode=2
    max_allowed_packet=256M

  resources:
    requests:
      cpu: 100m
      memory: 128Mi
    limits:
      memory: 16Gi

  livenessProbe:
    initialDelaySeconds: 40
    periodSeconds: 5
    timeoutSeconds: 5

  readinessProbe:
    initialDelaySeconds: 40
    periodSeconds: 5
    timeoutSeconds: 5

  metrics:
    enabled: {{ k8s_mariadbop_metrics }}
